%{
    #include <stdio.h>
    extern void yyerror(const char*);
    extern int yylex(void);
%}

%token KLART GATA HUS KORSNING GATUNAMN HUSNUMMER SEMIKOLON
%define parse.error verbose
%start inmatning

%%

inmatning : kommandon klartkommando ;

klartkommando : KLART SEMIKOLON ;

kommandon : kommandon kommando | %empty ;

kommando : gatukommando | huskommando | korsningskommando ;

gatukommando : GATA GATUNAMN SEMIKOLON ;

huskommando : HUS GATUNAMN HUSNUMMER SEMIKOLON ;

korsningskommando : KORSNING gatulista SEMIKOLON ;

gatulista : GATUNAMN GATUNAMN flergator ;

flergator : flergator GATUNAMN | %empty ;

%%

int main() {
    printf("Skriv in en inmatning. Avsluta med CTRL-D.\n");
    yyparse();
    printf("Done.\n");
    return 0;
}

void yyerror(const char *s) {
    printf("Goodbye. You have failed. This is how you failed: %s.\n", s);
}

int yywrap(void) {
    return 1;
}
